C==========================================================
      PROGRAM READDEMO

      IMPLICIT NONE
      INTEGER I,KS,KF,ORIG,EI,PZI,PTI,N,J,LSTRING
      INTEGER EH(2000),PZH(2000),PTH(2000)
      DOUBLEPRECISION PX,PY,PZ,PT,E,M
      CHARACTER*10 PARTICLE
      CHARACTER*80 LINES
     
      N=0

      DO J=1,2000
        EH(J)=0
        PZH(J)=0
        PTH(J)=0
      ENDDO

                  
      OPEN(UNIT=12,FILE='catfish-v2.10.dat',STATUS='UNKNOWN',ERR=9000)		
      OPEN(UNIT=13,FILE='catfish-v2.10.dat',STATUS='UNKNOWN',ERR=9000)		

      OPEN(UNIT=20,FILE='catfish-v2.10.gamma',STATUS='UNKNOWN')		
      OPEN(UNIT=21,FILE='catfish-v2.10.hist.gamma',
     ! STATUS='UNKNOWN')
      		
       
100   READ(12, '(A)',END=2000) LINES
      LSTRING = LEN(LINES)
      IF (LINES .EQ. '') goto 1000
      DO J=1,LSTRING
        IF (LINES(J:J+5) .EQ. 'gamma') THEN
          READ(13, *,ERR=9000) I,PARTICLE,KS,KF,ORIG,PX,PY,PZ,E,M
          IF (KS .GE. 1 .AND. KS .LE. 10) THEN
                N=N+1
	        PT=DSQRT(PX**2.0D0+PY**2.0D0)
                WRITE(20,'(I8,F15.3,F15.3,F15.3)') N,E,PZ,PT
                EI=IDINT(E/10.0D0+0.5D0)
		EH(EI+1)=EH(EI+1)+1
                PZI=IDINT(PZ/10.0D0+0.5D0)
		PZH(PZI+1)=PZH(PZI+1)+1
                PTI=IDINT(PT/10.0D0+0.5D0)
		PTH(PTI+1)=PTH(PTI+1)+1
              GOTO 100
          ENDIF
        ENDIF      	
      ENDDO
1000  READ(13, '(A)',END=2000) LINES
      GOTO 100	
	     
2000  DO J=1,1401
       WRITE(21,'(I8,I8,I8,I8)') (J-1)*10, EH(J),PZH(J),PTH(J)
      ENDDO

      CLOSE(12)
      CLOSE(13)
      CLOSE(20)
      CLOSE(21)
      
      RETURN

9000  OPEN(UNIT=99,FILE='catfish-v2.10.error',STATUS='UNKNOWN')		
      WRITE(99,*) 'Unreadable or missing file catfish-v2.10.dat'
      CLOSE(99)
      STOP      

      RETURN
      END PROGRAM READDEMO
C==========================================================


